/* Author: Jason Leigh
 * (C) 1997 Electronic Visualization Laboratory - Univ Illinois at Chicago
 */

#ifndef _CAVERN_IRBID_C
#define _CAVERN_IRBID_C

#include "CAVERN_includes.h++"
#include "cvrn_base.h++"

/** Class to specify a remote IRB to connect.
For now this is identified by IP and Port. In the future
we can use Globus to do it.
*/
class CAVERN_irbId_c {

public:

	/// Set address of remote IRB.
	void setAddress(char *ipAddr);

	/// Set port of remote IRB.
	void setPort(unsigned short prt = CAVERN_IRB_DEFAULT_MAIN_PORT);

	/// Get address.
	char *getAddress();

	/// Get Port.
	unsigned short getPort();

	CAVERN_irbId_c() {
		port = CAVERN_IRB_DEFAULT_MAIN_PORT;
	}

	// Returns the IRB address as a Nexus URL. This is generally NOT used by
	// user applications.
	char *getNexusURL();

private:

	char ip[256];
	unsigned short port;
	char nexusURL[cvrn_URL_SIZE];
	void generateNexusURL();

};

#endif
