/* Author: Jason Leigh
 * (C) 1997 Electronic Visualization Laboratory - Univ Illinois at Chicago
 */

#ifndef _CAVERN_IRB_MCAST_LINK_C
#define _CAVERN_IRB_MCAST_LINK_C

/** Multicast link management class.
For multicast there is practically nothing to manage except to unlink
it when done. Deleting the object will also unlink it.
*/
class CAVERN_irbMcastLink_c {

public:
	CAVERN_irbMcastLink_c(md5Key_c key,
			      unsigned long associatedMcastChannelId);
	~CAVERN_irbMcastLink_c();

	/// Unlink this link and hence unlink any keys linked to the multicast channel.
	void unlink();

private:
	md5Key_c channelBufferId;
	unsigned long mcastChannelId;
	int active;
};

#endif
