

#ifndef _CAVERNPLUS_MUTEX_C
#define _CAVERNPLUS_MUTEX_C

/**
Mutual exclusion class.

This class encapsulates mutual exclusion in a C++ object.

*/
class CAVERNplus_mutex_c {
public:

	enum mutexDebug_t {
		DEBUG_ON, DEBUG_OFF
	};

	/// Construct for a CAVERN mutual exclusion object.
	CAVERNplus_mutex_c();

	/// Lock the mutex object.
	void lock();

	/// Unlock mutex object.
	void unlock();

	/// Turn mutex debug messages on or off.
	void setMutexDebug(CAVERNplus_mutex_c::mutexDebug_t stat);

	/// Set the debug message to print whenever lock and unlock is performed.
	void setMutexDebugMesg(char *msg);

	/// Destructor for a CAVERN mutual exclusion object.
	~CAVERNplus_mutex_c();

	/// Return the nexus handle to the mutex variable.
	globus_mutex_t * getNexusMutex();

private:
	globus_mutex_t mutex;
	mutexDebug_t debugStat;
	char *debugMsg;
};

#endif
