/******-*- C -*-**************************************************************
globus_common.h.in

Description:
  Headers common to all of Globus

CVS Information:

  $Source: /home/globdev/CVS/globus-1998_04_16/Globus/Miscellaneous/common/library/globus_common.h.in,v $
  $Date: 1998/06/03 04:55:06 $
  $Revision: 1.1 $
  $State: Exp $
  $Author: bester $
******************************************************************************/

#if !defined(GLOBUS_INCLUDE_GLOBUS_COMMON_H)
#define GLOBUS_INCLUDE_GLOBUS_COMMON_H 1

/******************************************************************************
			       Type definitions
******************************************************************************/
typedef unsigned char	globus_byte_t;
typedef int		globus_bool_t;

/******************************************************************************
		      Include globus_common header files
******************************************************************************/
#include "globus_config.h"
#include "globus_release.h"
#include "globus_module.h"
#include "globus_url.h"
#include "globus_list.h"
#include "globus_hashtable.h"
#include "globus_fifo.h"
#include "globus_symboltable.h"
#include "globus_thread_pthreads.h"
#include "globus_poll.h"
#include "globus_error.h"
#include "globus_libc.h"
#include "globus_debug.h"


/*
 * globus_barrier_t
 *
 * A generic barrier structure
 */
typedef struct globus_barrier_s
{
    globus_mutex_t      mutex;
    globus_cond_t       cond;
    int                 count;
} globus_barrier_t;

/******************************************************************************
			       Define constants
******************************************************************************/

#define GLOBUS_SUCCESS  0

#define GLOBUS_TRUE	1
#define GLOBUS_FALSE	0

#define GLOBUS_NULL	0

#define GLOBUS_SUCCESS  0
#define GLOBUS_FAILURE  1



/******************************************************************************
				 Define macros
******************************************************************************/

/*
 * Various macro definitions for assertion checking
 */
#if defined(BUILD_DEBUG)
#   define globus_assert(assertion)					\
    {									\
        if (!(assertion))						\
        {								\
            fprintf(stderr, "Assertion " #assertion			\
		    " failed in file %s at line %d\n",			\
		    __FILE__, __LINE__);				\
	    abort();							\
         }								\
    }

#   define globus_assert_string(assertion, string)			\
    {									\
    	if (!(assertion))						\
    	{								\
    	    fprintf(stderr, "Assertion " #assertion			\
		    " failed in file %s at line %d: %s",		\
		    __FILE__, __LINE__, string);			\
	    abort();							\
    	}								\
    }
#else /* BUILD_DEBUG */
#   define globus_assert(assertion)
#   define globus_assert_string(assertion, string)
#endif /* BUILD_DEBUG */

#define GLOBUS_MAX(V1,V2) (((V1) > (V2)) ? (V1) : (V2))
#define GLOBUS_MIN(V1,V2) (((V1) < (V2)) ? (V1) : (V2))

 
/******************************************************************************
			  Module activation structure
******************************************************************************/
extern globus_module_descriptor_t	globus_i_common_module;

#define GLOBUS_COMMON_MODULE (&globus_i_common_module)


#endif /* GLOBUS_INCLUDE_GLOBUS_COMMON_H */
