/* Author: Jason Leigh
 * (C) 1997 Electronic Visualization Laboratory - Univ Illinois at Chicago
 */
#include "cvrn_base.h++"

#ifndef _CAVERN_initAttrib_c
#define _CAVERN_initAttrib_c


/** Class to set CAVERN initialization attributes.
With this you can choose the port to open for your personal IRB and you
can choose the name of the local CAVERN data-store. Other attributes
will be added with time.
*/
class CAVERN_initAttrib_c {
public:


	/** Change CAVERN default main port to something else. Must be
	a number greater than 6000. The main port is the port that all
	IRBs connect to first before establishing any other communication
	lines.
	*/
	void setPort(unsigned short thePort){mainPort = thePort;}

	/// Get default main port of CAVERN client.
	unsigned short getPort(){return mainPort;}

	/// Set the data store name. By default the datastore name is set as: CAVERN_DEFAULT_DB.
	void setDBName(char *dbRootName){
		strcpy(databaseRoot,dbRootName);
	}

	/// Get the data store name.
	char *getDBName() {return databaseRoot;}

	CAVERN_initAttrib_c() {
		mainPort = CAVERN_IRB_DEFAULT_MAIN_PORT;
		strcpy(databaseRoot,CAVERN_DEFAULT_DB_NAME);
	}
private:
	unsigned short mainPort;
	char databaseRoot[512];
};


#endif

