
#include "CAVERN_includes.h++"

#ifndef _CAVERN_irbKeyId_c
#define _CAVERN_irbKeyId_c

/** Class to specify a key's ID.
A key is identified by a path name and a name. Path's can be considered to
correspond to a UNIX directory hierarchy rooted at CAVERN's default
database directory (usually CAVERN_DEFAULT_DB). If the path is not
set or is set to NULL then the root database directory path is assumed.
*/
class CAVERN_irbKeyId_c {

public:


	/// Get the designated path of key.
	char *getPath();

	/// Get text name of key.
	char *getName();


	/** Set the designated path of key.
	e.g. setPath("foo/bar");
	*/
	void setPath(char*);

	/// Set text name of key.
	void setName(char*);

	// Get Hashed Id - not to be used publicly.
	md5Key_c getHashId();

	/// Get full combined path/name
	char *getFullName();

	CAVERN_irbKeyId_c();
	~CAVERN_irbKeyId_c();

private:

	char *path; 
	char *name;
	char *fullname;
	
	md5Key_c hashValue;

	void buildFullname();
};

#endif
