#ifndef _CAVERNPLUS_THREAD_C
#define _CAVERNPLUS_THREAD_C

#include "CAVERN.h++"

/**
Thread class. Note: the CAVERNplus_thread-related classes are intended to be
simplified versions of the nexus/pthread interfaces so that beginners
can quickly create threaded programs. For greater control over threads
use the nexus thread API which is very similar to the pthreads API.
*/
class CAVERNplus_thread_c {
public:

	/** Create a thread.
	    @param threaded_func is your function that will be called in
	    a separate thread. The function needs to be of the form:

	    void * threaded_func(void *arg);

	    @param arg is the argument to pass to the threaded function.
	    @return 0 if thread successful, else non-zero.
	    */
	int create(void * (*threaded_func)(void *), void *arg);

	/// Return nexus' thread handle.
	globus_thread_t *getNexusThread();

private:
	globus_thread_t itsThread;
};
#endif
