#ifndef _CAVERN_BASE
#define _CAVERN_BASE

#define CVRN_LOCK 1
#define CVRN_NOLOCK 0


/// CAVERN Boolean type.
enum CAVERN_bool_t {
	/// FALSE
	CAVERN_FALSE,
	/// TRUE
	CAVERN_TRUE
};

// Hash number generator types.
#include "md5Key_c.h++"

#include "_support_hashDict.h++"

// Default port of all IRBs.
extern unsigned short CAVERN_IRB_DEFAULT_MAIN_PORT;

// Default CAVERN database directory name.
extern char* CAVERN_DEFAULT_DB_NAME;

#define cvrn_URL_SIZE 256

extern char g_localAttachmentURL[cvrn_URL_SIZE];

/// Blocking/Non-blocking attribute type.
enum CAVERN_blocking_t  {
	/// Make an operation blocking.
	BLOCKING,
	/// Make an operation non-blocking (ie return immediately)
	NON_BLOCKING
};

int cvrnHostnameToIP(char *hostname, char *hostIP);
void cvrnGenerateNexusURL(char* nexusURL, char* ip, unsigned short port);
void cvrnGetHostname(char *name, int len);
void cvrnExpandName(char*src, char*newname, int len);


#endif

