/* CAVERN 9/10/96
 * (C) 1996 Jason Leigh
 *
 */

// Turn this on to do in function tracing.
//#define CVRN_TRACE



#ifndef _CVRN_DEBUG
#define _CVRN_DEBUG


#define DBG_MEM 32
#define DBG_ERR 2
#define DBG_MSG 4
#define DBG_FAIL 8
#define DBG_REF 16
#define DBG_PUB 1
#define DBG_LOCK 64
#define DBG_THREAD 128

#define DBG_ALL (!0)
#ifdef CVRN_TRACE
#define cvrnTrace(prefix,mesg) 	nexus_stdio_lock(); printf("  cavern: "); if (prefix) {printf(prefix); printf(":");}  printf(mesg); printf("\n"); fflush(stdout); nexus_stdio_unlock();
#else
#define cvrnTrace(prefix,mesg)
#endif


extern int _cvrnDebugLevel;
void cvrnSetDebugFilter(int);
void cvrnDebug(char* prefix, int lvl, char *fmt, ...);
void cvrnMesg(char *prefix, char *fmt, ...);

/**
A thread-safe printf. Use this rather than the standard printf to print
text to the TTY.

example 1:

cvrnPrintf("Hello %d %f", foo,bar);

prints something like:

Hello 123 32.4

@param fmt format string that you normally would have specified for
printf.
@param arguments for the format string.

*/
void cvrnPrintf(char *fmt, ...);




#endif
