#include "cvrn_nexus.h"
#include <stdio.h>

#ifdef __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif

#define	GLOBUS_NEXUS_EZ_HANDLER_ID 0

typedef struct
{
  globus_nexus_endpoint_t endpoint;
  globus_mutex_t mutex;
  globus_cond_t cond;
  globus_bool_t done;
  char *reply_format;
  struct s_node_t *node;
} globus_nexus_ez_rpchandle_t;

#ifdef __STDC__
int globus_nexus_ez_rpc_unpack_1sided(globus_nexus_buffer_t *buffer, char *format, ...);
#else
int globus_nexus_ez_rpc_unpack_1sided();
#endif

#ifdef __STDC__
int globus_nexus_ez_rpc_1sided(globus_nexus_startpoint_t *sp, int handler_id, 
			globus_bool_t called_from_nonthread_h,
			char *format, ...);
#else
int globus_nexus_ez_rpc_1sided();
#endif

#ifdef __STDC__
int globus_nexus_ez_asynch(globus_nexus_startpoint_t *sp, int handler_id, 
			globus_nexus_ez_rpchandle_t *rpchandle, 
			globus_bool_t called_from_nonthread_h,
			char *format1,  ...); 
#else
int globus_nexus_ez_asynch();
#endif

#ifdef __STDC__
int globus_nexus_ez_rpc_unpack(globus_nexus_buffer_t *buffer,
		        globus_nexus_startpoint_t *reply_sp, 
			char *format, ...); 
#else
int globus_nexus_ez_rpc_unpack();
#endif

int globus_nexus_ez_rpc_wait(globus_nexus_ez_rpchandle_t *rpchandle);

int globus_nexus_ez_rpc_probe(globus_nexus_ez_rpchandle_t rpchandle, int *status);

#ifdef __STDC__
int globus_nexus_ez_rpc(globus_nexus_startpoint_t *sp, int handler_id, 
			globus_bool_t called_from_nonthread_h,
			char *format1, ...); 
#else
int globus_nexus_ez_rpc();
#endif

void globus_nexus_ez_destroy_rpchandle(globus_nexus_ez_rpchandle_t *rpchandle);

