/*

LIMBO ZERO

(C) 1998 Jason Leigh, Electronic Visualization Laboratory,
Univ Illinois at Chicago

*/

#include "lim_global.h++"
#include "lim_perf.h++"
#include "lim_avatar.h++"

// Pointer to the main CAVERN Information Resource Broker.
CAVERN_irb_c *g_limPIRB = NULL;

// Flag to tell if you are going to try and connect to a remote server.
int g_limRemoteConnect = 0;
void limCAVERNInit(int *argc, char*** argv);

// LIMBO ZERO Initialization.
void limInit(int *argc, char*** argv)
{
	if (*argc < 2) {
		fprintf(stderr,"%s: usage: %s [server address] user_name\n",*argv[0],*argv[0]);
		exit(1);
	}


	if (*argc > 2) g_limRemoteConnect = 1;

	// Initialize Performer
	limPerformerInit(argc, argv);

	// Add the avatar objects to the scene database.
	addAvatarMainDCS();

	// Initialize CAVERN
	limCAVERNInit(argc, argv);

	// Let performer do one loop. Needed because of strange
	// anomaly between Performer locking and pthreads.
	limPerfOneCycle();

	// Initialize avatars.
	limAvatarInit(*argv);
}

// Initialize CAVERN.
void limCAVERNInit(int *argc, char*** argv)
{
	/// Startup CAVERN.
	g_limPIRB = CAVERNInit(argc, argv, NULL);
	if (!g_limPIRB) {
		exit(1);
	}
	
}

// Handle when a channel is broken.
void limChannelCB(CAVERN_irbChannel_c::CAVERN_channelEvent_t event,
		 CAVERN_irbChannel_c *thisChannel,
		 void* userData)
{
	if (event == CAVERN_irbChannel_c::BROKEN_CHANNEL) {
		cvrnMesg(NULL,"CHANNEL BROKEN!");
	}
}

