/*

LIMBO ZERO

(C) 1998 Jason Leigh, Electronic Visualization Laboratory,
Univ Illinois at Chicago

*/

#include "lim_perf.h++"
#include "lim_navigate.h++"
#include "lim_avatar.h++"

// CAVE Program main loop.
void limMainLoop()
{

	while (!CAVEgetbutton(CAVE_ESCKEY))
	{

		// Position and orient ray along wand.
		limUpdateWand();

		limCheckForNewAvatars();

		// Required by performer to synch things to a certain frame rate.
		pfSync();

		// Updates tracker data and sets up new projects for each channel.
		pfCAVEPreFrame();

		// Required by performer to trigger cull and draw
		pfFrame();

		// Updates non latency critical data.
		pfCAVEPostFrame();

		// Perform navigation.
		limNavigate(g_limMainGroup);

		// Send your own avatar information to everyone.
		limSendSelfAvatarTracker();

	}

	// Say bye to all the other avatars.
	limAvatarExit();

	CAVEHalt();
	pfExit();

}
