/* Author: Jason Leigh
 * (C) 1997 Electronic Visualization Laboratory - Univ Illinois at Chicago
 */

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <sys/time.h>

double getTimeInSecs()
{
	//  const double oneMicroSec = 0.000001;
        static struct timeval timeSec;
        static struct timezone tzone;

        gettimeofday(&timeSec, &tzone);

        return (timeSec.tv_sec);
}

main(int argc, char**argv)
{
	FILE *fp;

	if (argc < 2) {
		printf("\nusage: %s unix_file\n", argv[0]);
		printf("This little tool takes any UNIX file and makes it part of\n");
		printf("a CAVERNsoft database hierarchy.\n\n");
		printf("Simply move the unix file into the location in the CAVERN\n");
		printf("database directory hierarchy and then invoke this program\n");
		printf("on the file. This file will now be accessible from within\n");
		printf("CAVERNsoft.\n\n");

		exit(1);
	}

	fp = fopen(argv[1],"r");

	if (!fp) {
		printf("%s: unable to open %s\n",argv[0], argv[1]);
		exit(1);
	}

	fseek(fp,0,SEEK_END);

	long length = ftell(fp);

	fclose(fp);

	double theTime = getTimeInSecs();
	char metaFile[512];

	sprintf(metaFile,"%s._meta",argv[1]);
	fp = fopen(metaFile,"w");
	if (!fp) {
		printf("%s: unable to open database meta file: %s\n",argv[0], argv[1]);
		exit(1);
	}

	fprintf(fp,"%ld %lf %lf 0\n",
		length, theTime, theTime);
	fclose(fp);

}
