#ifndef _kBullet_h_
#define _kBullet_h_

#include <Performer/pfdu.h>
#include <Performer/pf/pfGeode.h>
#include <Performer/pf/pfTraverser.h>
#include <Performer/pf/pfDCS.h>
#include <Performer/pr/pfLinMath.h>
#include <pfcave.h>
extern int g_limGameScore;

class kBullet : public pfDCS
	{
	public:
	 kBullet(pfVec3, pfVec3, int);
	 virtual void setGravity(float g);
	 virtual void setWorld(pfNode *);
	private:
	 pfVec3 position_;
	 pfVec3 velocity_;
	 float gravity_;
	 float prevTime_;
	 int active_;
	 int mine_;
	 pfNode *world_;
	/* Stuff needed for APP traversal of node */
	public:
	 virtual int app(pfTraverser*);
	 virtual int needsApp(void);
	 int isActive();
	private:
	 int hitObject(pfVec3);
	/* Stuff required to make this a Performer class */
	public:
	 static void init(void);
	 static pfType* getClassType(void){ return classType_; };
	private:
	 static pfType* classType_;
	};

#endif
