#ifndef _kPartList_h_
#define _kPartList_h_

#include <Performer/pfdu.h>
#include <Performer/pf/pfGeode.h>
#include <Performer/pf/pfTraverser.h>
#include <Performer/pf/pfDCS.h>
#include <Performer/pr/pfLinMath.h>
#include <pfcave.h>
#include "lim_global.h++"
#include "lim_avatar.h++"


#define MAX_COLLABORATORS 25

class kPartList : public pfDCS
{
public:
  kPartList();
  virtual void setWorld(pfNode *);

private:
  pfDCS *titleDCS;
  pfDCS *new_avDCS;
  pfText *new_avText;
  pfString *new_avString;
  pfText *titleText;
  int num_collaborators;
  pfVec3 position_;
  pfGroup *blips;
  float prevTime_;
  int active_;
  pfNode *world_;
  pfFont *fnt;
	
/* Stuff needed for APP traversal of node */
public:
  virtual int app(pfTraverser*);
  virtual int needsApp(void);
  int isActive();
  double getDistance(pfVec3, pfVec3);
  void HandleNameIsect();

/* Stuff required to make this a Performer class */
public:
  static void init(void);
  static pfType* getClassType(void){ return classType_; };
private:
  static pfType* classType_;
};

#endif
