#include "lim_global.h++"
#include "lim_audio.h++"
#include "lim_model.h++"
#include "lim_perf.h++"
#include "lim_avatar.h++"
#include "lim_bullet.h++"

CAVERN_irb_c *g_limPIRB = NULL;
void limCAVERNInit(int *argc, char*** argv);
int g_limRemoteConnect = 0;

void limInit(int *argc, char*** argv)
{
	if (*argc < 2) {
		fprintf(stderr,"%s: usage: %s [server address] user_name\n",*argv[0],*argv[0]);
		exit(1);
	}


	if (*argc > 2) g_limRemoteConnect = 1;

	limPerformerInit(argc, argv);
	addAvatarMainDCS();

	limCAVERNInit(argc, argv);
	limBulletInit(*argv);
	limAudioInit(*argv);
	limModelInit(*argv);

	limPerfOneCycle();

	limAvatarInit(*argv);
}

void limCAVERNInit(int *argc, char*** argv)
{
	/// Startup CAVERN.
	g_limPIRB = CAVERNInit(argc, argv, NULL);
	if (!g_limPIRB) {
		exit(1);
	}
	
}

// Handle when a channel is broken.
void limChannelCB(CAVERN_irbChannel_c::CAVERN_channelEvent_t event,
		 CAVERN_irbChannel_c *thisChannel,
		 void* userData)
{
	if (event == CAVERN_irbChannel_c::BROKEN_CHANNEL) {
		cvrnMesg(NULL,"CHANNEL BROKEN!");
	}
}

