#include "lim_perf.h++"
#define _LIM_CRUISE_SPEED 1.0
#define _LIM_TURN_SPEED 2

float g_limCurrentCaveTurn = 0;

void limNavigate(pfDCS *dcs)
{
	/* Do normal CAVE navigation */
	float jx=CAVE_JOYSTICK_X,jy=CAVE_JOYSTICK_Y;
	if (fabs(jx) > 0.2) {
		CAVENavRot(-_LIM_TURN_SPEED*jx,'z');
		g_limCurrentCaveTurn += (_LIM_TURN_SPEED * jx);
	}

	if (fabs(jy) > 0.2)
	{
		float w[3];
		CAVEGetVector(CAVE_WAND_FRONT,w);

		// Lock navigation to floor
		CAVENavTranslate(w[0]*jy*_LIM_CRUISE_SPEED,
				 w[1]*jy*_LIM_CRUISE_SPEED,
				 w[2]*jy*_LIM_CRUISE_SPEED);

		float headPos[3], localHeadPos[3];
		float diff;
		CAVEGetPosition(CAVE_HEAD_NAV, headPos);
		CAVEGetPosition(CAVE_HEAD,localHeadPos);
		diff = headPos[2] - localHeadPos[2];
		if (diff < 0) {
			CAVENavTranslate(0,0,-diff);
		}

	}


	/*
	if (CAVEButtonChange(3) == -1)
		CAVENavLoadIdentity();
	*/

	/* Store the CAVE navigation in the DCS */
	pfCAVEDCSNavTransform(dcs);
}
