#include "ra.h++"

audioRecorder :: audioRecorder()
{
	buf = NULL;
}

audioRecorder :: ~audioRecorder()
{
	if (buf) delete buf;
}

int audioRecorder :: init(char *fname)
{

    strcpy(outfilename,fname);

    /*
     * SETt the global IRIS Audio Processor input rate to 11025.
     */
    pvbuf[0] = AL_INPUT_RATE;
    pvbuf[1] = AL_RATE_11025;
    portrate = pvbuf[1];
    ALsetparams(AL_DEFAULT_DEVICE, pvbuf, 2);

    filerate = 11025.0;

    /*
     * initialize the audio port and audio file configuration
     */
    portchannels    = AL_MONO;              /* port channels      */
    portsampwidth   = AL_SAMPLE_16;           /* port sample width  */
    portsampfmt     = AL_SAMPFMT_TWOSCOMP;    /* port sample format */
    filechannels    = 1;                      /* file  channels     */
    filesampwidth   = 16;                     /* file sample width  */
    filesampfmt     = AF_SAMPFMT_TWOSCOMP;    /* file sample format */


    /*
     * compute the number of input samples equal to half a 
     * second and allocate a transfer buffer
     */
    samplespersec   = ((long)filerate); /* mono             */
    samplesperbuf   = samplespersec/2;    /* half second buffer */
    framesperbuf    = samplesperbuf;    /* stereo             */
    if (buf) delete buf;
    buf             = (short *)malloc(samplesperbuf * sizeof(short));
    /*
     * open the audio port
     */
    portconfig    = ALnewconfig();
    ALsetchannels(portconfig, portchannels);
    ALsetwidth(portconfig, portsampwidth);
    ALsetqueuesize(portconfig, samplesperbuf);
    port = ALopenport("spiffy", "r", portconfig);
    /* 
     * configure an audio file 
     */
    filesetup    = AFnewfilesetup();
    AFinitfilefmt(filesetup, AF_FILE_AIFFC); 

    AFinitchannels(filesetup, AF_DEFAULT_TRACK,  filechannels);
    AFinitrate(filesetup, AF_DEFAULT_TRACK, filerate);
    AFinitsampfmt(filesetup, AF_DEFAULT_TRACK, 
                      AF_SAMPFMT_TWOSCOMP, filesampwidth); /*in bits */
    /*
     * open the audio file
     */
    fileHandle = AFopenfile(outfilename, "w", filesetup);
    if (fileHandle) return 1;
    else return 0;

}

int audioRecorder :: record()
{
        ALreadsamps(port, buf, samplesperbuf);
        if ((numframeswrit 
                 = AFwriteframes(fileHandle, AF_DEFAULT_TRACK, 
                             buf, framesperbuf)) < framesperbuf)
        {
		return 0;
        }
	return 1;

}

void audioRecorder :: stop()
{
    /* this is important: it updates the file header */

    AFclosefile(fileHandle); 
    ALcloseport(port);
}
