#include <stdio.h>
#include <signal.h>
#include <dmedia/audio.h>
#include <dmedia/audiofile.h>


class audioRecorder {
public:
	int init(char *fname);
	int record();
	void stop();
	audioRecorder();
	~audioRecorder();

private:
    ALconfig      portconfig;         /* audio port configuration          */
    ALport        port;               /* audio port                        */
    long          portchannels;       /* audio port channels               */
    long          portrate;           /* audio port sampling rate          */
    long          portsampwidth;      /* audio port sample width           */
    long          portsampfmt;        /* audio port sample format          */
    AFfilesetup   filesetup;          /* audio file setup                  */
    AFfilehandle  fileHandle;         /* audio file handle                 */
    char          outfilename[256];   /* audio file name                   */
    long          filechannels;       /* audio file channels               */
    double        filerate;           /* audio file sampling rate          */
    long          filesampwidth;      /* audio file sample width           */
    long          filesampfmt;        /* audio file sample format          */
    long          pvbuf[2];           /* parameter-value buffer            */
    void         *buf;                /* sample transfer buffer            */
    int           numframeswrit;      /* number of frames written          */
    int           done;               /* flag                              */
    int           samplesperbuf;      /* samples transfered per loop       */
    int           framesperbuf;       /* sample frames transfered per loop */
    int           samplespersec;      /* samples transfered per sec        */

};
