#include "lim_global.h++"
#include "lim_perf.h++"
#include <unistd.h>
#include "teleport.h++"
#include "lim_avatar.h++"
#include "lim_model.h++"

pfDCS *g_limTeleportDCS = NULL;
pfNode *g_limGenericPort = NULL;

pfType *Teleport::classType_ = NULL;

// took this from somewhere else, it initializes performer and sets the class type
void Teleport::init(void)
{
 if (classType_ == NULL)
 {
   pfDCS::init();				/* Initialize the parent class */
   classType_ =  new pfType(pfDCS::getClassType(), "Teleport");	
   /* Create the new pfType for this class, based on the parent class's type */
 }
}

Teleport::Teleport() 
{ }

Teleport::Teleport(pfVec3 init_pos)
{
  door_position[0]=init_pos[0];
  door_position[1]=init_pos[1];
  door_position[2]=init_pos[2];

  return;
}

Teleport::Teleport(pfVec3 init_pos, pfVec3 init_exit, pfBox &init_bounds, int id)
{
  // g_limTeleportDCS = new pfDCS;
  id_number = id;
  
  door_position[0]=init_pos[0];
  door_position[1]=init_pos[1];
  door_position[2]=init_pos[2];

  exit_position[0]=init_exit[0];
  exit_position[1]=init_exit[1];
  exit_position[2]=init_exit[2];
 
  port_bounds.min[0]=init_bounds.min[0];
  port_bounds.min[1]=init_bounds.min[1];
  port_bounds.min[2]=init_bounds.min[2];
 
  port_bounds.max[0]=init_bounds.max[0];
  port_bounds.max[1]=init_bounds.max[1];
  port_bounds.max[2]=init_bounds.max[2];

  cvrnPrintf("returning from constructor\n");
  return;
}

void Teleport::DrawTeleport(pfDCS* parent)
{
  pfDCS *newPort;
  pfGeoSet *gsetPort;
  pfGeode *gPort;
  pfVec4 *colorAttr;
  pfMatrix matrix;
  pfGeoState *portState;

  newPort = new pfDCS;
  gsetPort = pfdNewCube(pfGetSharedArena());
  colorAttr = (pfVec4 *)pfMalloc(sizeof(pfVec4), pfGetSharedArena());
  colorAttr->vec[0] = 1.0f;
  colorAttr->vec[1] = 0.0f;
  colorAttr->vec[2] = 0.00f;
  colorAttr->vec[3] = 0.1f;
  gPort = new pfGeode;
  portState = new pfGeoState;
  portState->setMode(PFSTATE_TRANSPARENCY, PFTR_ON);
  gsetPort->setGState(portState);
  gsetPort->setAttr(PFGS_COLOR4,PFGS_OVERALL,colorAttr,NULL);
  gsetPort->setDrawMode(PFGS_FLATSHADE, 1);
  matrix.makeScale(5.0,0.0,20.0);
  pfdXformGSet(gsetPort,matrix);
  gPort->addGSet(gsetPort);
  newPort->addChild(gPort);
  newPort->setTrans(door_position[0],door_position[1],door_position[2]);
  parent->addChild(newPort);
  return;
}


int Teleport::IsInBox(const pfVec3 av_loc)
{ 
  if(port_bounds.contains(av_loc)) { return 1; }
  return 0;
}

pfVec3 Teleport::GetPosition()
{
  return door_position;
}

pfVec3 Teleport::GetExit()
{
  return exit_position;
}

void Teleport::PortObject(/*pfDCS *av*/)
{
 CAVENavLoadIdentity();
 CAVENavTranslate(exit_position[0],exit_position[1]+30,exit_position[2]);
}

int Teleport::app(pfTraverser *trav)
{
  float loc[3];
  pfVec3 myLoc;
  CAVEGetPosition(CAVE_WAND, loc);
  CAVENavConvertCAVEToWorld(loc, myLoc.vec);

  //  cvrnPrintf("%d\n", id_number);

  if(IsInBox(myLoc)) { 
    cvrnPrintf("%d\n", id_number);
    cvrnPrintf("intersected box\n");
    PortObject();
  }                 
  return pfDCS::app(trav);
}
  

int Teleport::needsApp(void)
{
 return TRUE;
}

Teleport::~Teleport()
{
}


    



